]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
Merge branch 'master' of git://git.denx.de/u-boot-mmc
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier: GPL-2.0+
7
8 usage()
9 {
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -l, --list List all targets to be built
22 -m, --maintainers List all targets and maintainer email
23 -M, --mails List all targets and all affilated emails
24 -C, --check Enable build checking
25 -n, --continue Continue (skip boards already built)
26 -r, --rebuild-errors Rebuild any boards that errored
27 -h, --help This help output
28
29 Selections by these options are logically ANDed; if the same option
30 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
31 will select all configurations where the vendor is either FOO or
32 BAR. Any additional arguments specified on the command line are
33 always build additionally. See the boards.cfg file for more info.
34
35 If no boards are specified, then the default is "powerpc".
36
37 Environment variables:
38 BUILD_NCPUS number of parallel make jobs (default: auto)
39 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
40 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
41 architecture "ARCH". Substitute "ARCH" for any
42 supported architecture (default: "")
43 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
44 BUILD_DIR output build directory (default: ./)
45 BUILD_NBUILDS number of parallel targets (default: 1)
46
47 Examples:
48 - build all Power Architecture boards:
49 MAKEALL -a powerpc
50 MAKEALL --arch powerpc
51 MAKEALL powerpc
52 - build all PowerPC boards manufactured by vendor "esd":
53 MAKEALL -a powerpc -v esd
54 - build all PowerPC boards manufactured either by "keymile" or "siemens":
55 MAKEALL -a powerpc -v keymile -v siemens
56 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
57 MAKEALL -c mpc83xx -v freescale 4xx
58 EOF
59 exit ${ret}
60 }
61
62 SHORT_OPTS="ha:c:v:s:lmMCnr"
63 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails,check,continue,rebuild-errors"
64
65 # Option processing based on util-linux-2.13/getopt-parse.bash
66
67 # Note that we use `"$@"' to let each command-line parameter expand to a
68 # separate word. The quotes around `$@' are essential!
69 # We need TEMP as the `eval set --' would nuke the return value of
70 # getopt.
71 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
72 -n 'MAKEALL' -- "$@"`
73
74 [ $? != 0 ] && usage 1
75
76 # Note the quotes around `$TEMP': they are essential!
77 eval set -- "$TEMP"
78
79 SELECTED=''
80 ONLY_LIST=''
81 PRINT_MAINTS=''
82 MAINTAINERS_ONLY=''
83 CONTINUE=''
84 REBUILD_ERRORS=''
85
86 while true ; do
87 case "$1" in
88 -a|--arch)
89 # echo "Option ARCH: argument \`$2'"
90 if [ "$opt_a" ] ; then
91 opt_a="${opt_a%)} || \$2 == \"$2\")"
92 else
93 opt_a="(\$2 == \"$2\")"
94 fi
95 SELECTED='y'
96 shift 2 ;;
97 -c|--cpu)
98 # echo "Option CPU: argument \`$2'"
99 if [ "$opt_c" ] ; then
100 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
101 else
102 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
103 fi
104 SELECTED='y'
105 shift 2 ;;
106 -s|--soc)
107 # echo "Option SoC: argument \`$2'"
108 if [ "$opt_s" ] ; then
109 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
110 else
111 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
112 fi
113 SELECTED='y'
114 shift 2 ;;
115 -v|--vendor)
116 # echo "Option VENDOR: argument \`$2'"
117 if [ "$opt_v" ] ; then
118 opt_v="${opt_v%)} || \$5 == \"$2\")"
119 else
120 opt_v="(\$5 == \"$2\")"
121 fi
122 SELECTED='y'
123 shift 2 ;;
124 -C|--check)
125 CHECK='C=1'
126 shift ;;
127 -n|--continue)
128 CONTINUE='y'
129 shift ;;
130 -r|--rebuild-errors)
131 REBUILD_ERRORS='y'
132 shift ;;
133 -l|--list)
134 ONLY_LIST='y'
135 shift ;;
136 -m|--maintainers)
137 ONLY_LIST='y'
138 PRINT_MAINTS='y'
139 MAINTAINERS_ONLY='y'
140 shift ;;
141 -M|--mails)
142 ONLY_LIST='y'
143 PRINT_MAINTS='y'
144 shift ;;
145 -h|--help)
146 usage ;;
147 --)
148 shift ; break ;;
149 *)
150 echo "Internal error!" >&2 ; exit 1 ;;
151 esac
152 done
153 # echo "Remaining arguments:"
154 # for arg do echo '--> '"\`$arg'" ; done
155
156 FILTER="\$1 !~ /^#/"
157 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
158 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
159 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
160 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
161
162 if [ "$SELECTED" ] ; then
163 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
164
165 # Make sure some boards from boards.cfg are actually found
166 if [ -z "$SELECTED" ] ; then
167 echo "Error: No boards selected, invalid arguments"
168 exit 1
169 fi
170 fi
171
172 #########################################################################
173
174 # Print statistics when we exit
175 trap exit 1 2 3 15
176 trap print_stats 0
177
178 # Determine number of CPU cores if no default was set
179 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
180
181 if [ "$BUILD_NCPUS" -gt 1 ]
182 then
183 JOBS="-j $((BUILD_NCPUS + 1))"
184 else
185 JOBS=""
186 fi
187
188 if [ "${MAKEALL_LOGDIR}" ] ; then
189 LOG_DIR=${MAKEALL_LOGDIR}
190 else
191 LOG_DIR="LOG"
192 fi
193
194 : ${BUILD_NBUILDS:=1}
195 BUILD_MANY=0
196
197 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
198 BUILD_MANY=1
199 : ${BUILD_DIR:=./build}
200 mkdir -p "${BUILD_DIR}/ERR"
201 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
202 fi
203
204 : ${BUILD_DIR:=.}
205
206 OUTPUT_PREFIX="${BUILD_DIR}"
207
208 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
209 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
210 find "${LOG_DIR}/" -type f -exec rm -f {} +
211 fi
212
213 LIST=""
214
215 # Keep track of the number of builds and errors
216 ERR_CNT=0
217 ERR_LIST=""
218 WRN_CNT=0
219 WRN_LIST=""
220 TOTAL_CNT=0
221 SKIP_CNT=0
222 CURRENT_CNT=0
223 OLDEST_IDX=1
224 RC=0
225
226 # Helper funcs for parsing boards.cfg
227 boards_by_field()
228 {
229 FS="[ \t]+"
230 [ -n "$3" ] && FS="$3"
231 awk \
232 -v field="$1" \
233 -v select="$2" \
234 -F "$FS" \
235 '($1 !~ /^#/ && $field == select) { print $7 }' \
236 boards.cfg
237 }
238 boards_by_arch() { boards_by_field 2 "$@" ; }
239 boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
240 boards_by_soc() { boards_by_field 4 "$@" ; }
241
242 #########################################################################
243 ## MPC5xx Systems
244 #########################################################################
245
246 LIST_5xx="$(boards_by_cpu mpc5xx)"
247
248 #########################################################################
249 ## MPC5xxx Systems
250 #########################################################################
251
252 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
253
254 #########################################################################
255 ## MPC512x Systems
256 #########################################################################
257
258 LIST_512x="$(boards_by_cpu mpc512x)"
259
260 #########################################################################
261 ## MPC8xx Systems
262 #########################################################################
263
264 LIST_8xx="$(boards_by_cpu mpc8xx)"
265
266 #########################################################################
267 ## PPC4xx Systems
268 #########################################################################
269
270 LIST_4xx="$(boards_by_cpu ppc4xx)"
271
272 #########################################################################
273 ## MPC824x Systems
274 #########################################################################
275
276 LIST_824x="$(boards_by_cpu mpc824x)"
277
278 #########################################################################
279 ## MPC8260 Systems (includes 8250, 8255 etc.)
280 #########################################################################
281
282 LIST_8260="$(boards_by_cpu mpc8260)"
283
284 #########################################################################
285 ## MPC83xx Systems (includes 8349, etc.)
286 #########################################################################
287
288 LIST_83xx="$(boards_by_cpu mpc83xx)"
289
290 #########################################################################
291 ## MPC85xx Systems (includes 8540, 8560 etc.)
292 #########################################################################
293
294 LIST_85xx="$(boards_by_cpu mpc85xx)"
295
296 #########################################################################
297 ## MPC86xx Systems
298 #########################################################################
299
300 LIST_86xx="$(boards_by_cpu mpc86xx)"
301
302 #########################################################################
303 ## 74xx/7xx Systems
304 #########################################################################
305
306 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
307
308 #########################################################################
309 ## PowerPC groups
310 #########################################################################
311
312 LIST_TSEC=" \
313 ${LIST_83xx} \
314 ${LIST_85xx} \
315 ${LIST_86xx} \
316 "
317
318 LIST_powerpc=" \
319 ${LIST_5xx} \
320 ${LIST_512x} \
321 ${LIST_5xxx} \
322 ${LIST_8xx} \
323 ${LIST_824x} \
324 ${LIST_8260} \
325 ${LIST_83xx} \
326 ${LIST_85xx} \
327 ${LIST_86xx} \
328 ${LIST_4xx} \
329 ${LIST_74xx_7xx}\
330 "
331
332 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
333 # still using "ppc" instead of "powerpc"
334 LIST_ppc=" \
335 ${LIST_powerpc} \
336 "
337
338 #########################################################################
339 ## StrongARM Systems
340 #########################################################################
341
342 LIST_SA="$(boards_by_cpu sa1100)"
343
344 #########################################################################
345 ## ARM7 Systems
346 #########################################################################
347
348 LIST_ARM7="$(boards_by_cpu arm720t)"
349
350 #########################################################################
351 ## ARM9 Systems
352 #########################################################################
353
354 LIST_ARM9="$(boards_by_cpu arm920t) \
355 $(boards_by_cpu arm926ejs) \
356 $(boards_by_cpu arm925t) \
357 $(boards_by_cpu arm946es) \
358 "
359
360 #########################################################################
361 ## ARM11 Systems
362 #########################################################################
363 LIST_ARM11="$(boards_by_cpu arm1136) \
364 $(boards_by_cpu arm1176) \
365 "
366
367 #########################################################################
368 ## ARMV7 Systems
369 #########################################################################
370
371 LIST_ARMV7="$(boards_by_cpu armv7)"
372
373 #########################################################################
374 ## AT91 Systems
375 #########################################################################
376
377 LIST_at91="$(boards_by_soc at91)"
378
379 #########################################################################
380 ## Xscale Systems
381 #########################################################################
382
383 LIST_pxa="$(boards_by_cpu pxa)"
384
385 LIST_ixp="$(boards_by_cpu ixp)"
386
387 #########################################################################
388 ## SPEAr Systems
389 #########################################################################
390
391 LIST_spear="$(boards_by_soc spear)"
392
393 #########################################################################
394 ## ARM groups
395 #########################################################################
396
397 LIST_arm="$(boards_by_arch arm)"
398
399 #########################################################################
400 ## MIPS Systems (default = big endian)
401 #########################################################################
402
403 LIST_mips4kc=" \
404 incaip \
405 incaip_100MHz \
406 incaip_133MHz \
407 incaip_150MHz \
408 qemu_mips \
409 vct_platinum \
410 vct_platinum_small \
411 vct_platinum_onenand \
412 vct_platinum_onenand_small \
413 vct_platinumavc \
414 vct_platinumavc_small \
415 vct_platinumavc_onenand \
416 vct_platinumavc_onenand_small \
417 vct_premium \
418 vct_premium_small \
419 vct_premium_onenand \
420 vct_premium_onenand_small \
421 "
422
423 LIST_au1xx0=" \
424 dbau1000 \
425 dbau1100 \
426 dbau1500 \
427 dbau1550 \
428 "
429
430 LIST_mips=" \
431 ${LIST_mips4kc} \
432 ${LIST_mips5kc} \
433 ${LIST_au1xx0} \
434 "
435
436 #########################################################################
437 ## MIPS Systems (little endian)
438 #########################################################################
439
440 LIST_au1xx0_el=" \
441 dbau1550_el \
442 pb1000 \
443 "
444 LIST_mips_el=" \
445 ${LIST_au1xx0_el} \
446 "
447 #########################################################################
448 ## OpenRISC Systems
449 #########################################################################
450
451 LIST_openrisc="$(boards_by_arch openrisc)"
452
453 #########################################################################
454 ## x86 Systems
455 #########################################################################
456
457 LIST_x86="$(boards_by_arch x86)"
458
459 #########################################################################
460 ## Nios-II Systems
461 #########################################################################
462
463 LIST_nios2="$(boards_by_arch nios2)"
464
465 #########################################################################
466 ## MicroBlaze Systems
467 #########################################################################
468
469 LIST_microblaze="$(boards_by_arch microblaze)"
470
471 #########################################################################
472 ## ColdFire Systems
473 #########################################################################
474
475 LIST_m68k="$(boards_by_arch m68k)"
476 LIST_coldfire=${LIST_m68k}
477
478 #########################################################################
479 ## AVR32 Systems
480 #########################################################################
481
482 LIST_avr32="$(boards_by_arch avr32)"
483
484 #########################################################################
485 ## Blackfin Systems
486 #########################################################################
487
488 LIST_blackfin="$(boards_by_arch blackfin)"
489
490 #########################################################################
491 ## SH Systems
492 #########################################################################
493
494 LIST_sh2="$(boards_by_cpu sh2)"
495 LIST_sh3="$(boards_by_cpu sh3)"
496 LIST_sh4="$(boards_by_cpu sh4)"
497
498 LIST_sh="$(boards_by_arch sh)"
499
500 #########################################################################
501 ## SPARC Systems
502 #########################################################################
503
504 LIST_sparc="$(boards_by_arch sparc)"
505
506 #########################################################################
507 ## NDS32 Systems
508 #########################################################################
509
510 LIST_nds32="$(boards_by_arch nds32)"
511
512 #-----------------------------------------------------------------------
513
514 get_target_location() {
515 local target=$1
516 local BOARD_NAME=""
517 local CONFIG_NAME=""
518 local board=""
519 local vendor=""
520
521 # Automatic mode
522 local line=`awk -F '\ +' '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
523 if [ -z "${line}" ] ; then echo "" ; return ; fi
524
525 set ${line}
526
527 CONFIG_NAME="${7%_config}"
528
529 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}"
530
531 if [ $# -gt 5 ]; then
532 if [ "$6" = "-" ] ; then
533 board=${BOARD_NAME}
534 else
535 board="$6"
536 fi
537 fi
538
539 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
540 [ $# -gt 6 ] && [ "$8" != "-" ] && {
541 tmp="${8%:*}"
542 if [ "$tmp" ] ; then
543 CONFIG_NAME="$tmp"
544 fi
545 }
546
547 # Assign board directory to BOARDIR variable
548 if [ "${vendor}" == "-" ] ; then
549 BOARDDIR=${board}
550 else
551 BOARDDIR=${vendor}/${board}
552 fi
553
554 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
555 }
556
557 get_target_maintainers() {
558 local name=`echo $1 | cut -d : -f 3`
559
560 local line=`awk -F '\ +' '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
561 if [ -z "${line}" ]; then
562 echo ""
563 return ;
564 fi
565
566 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
567 [ "$mails" == "-" ] && mails=""
568 echo "$mails"
569 }
570
571 get_target_arch() {
572 local target=$1
573
574 # Automatic mode
575 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
576
577 if [ -z "${line}" ] ; then echo "" ; return ; fi
578
579 set ${line}
580 echo "$2"
581 }
582
583 list_target() {
584 if [ "$PRINT_MAINTS" != 'y' ] ; then
585 echo "$1"
586 return
587 fi
588
589 echo -n "$1:"
590
591 local loc=`get_target_location $1`
592
593 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
594
595 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
596
597 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
598
599 local dir=`echo ${loc} | cut -d ":" -f 2`
600 local cfg=`echo ${loc} | cut -d ":" -f 1`
601 local git_result=`git log --format=%aE board/${dir} \
602 include/configs/${cfg}.h | grep "@"`
603 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
604 head -n 3`
605 local git_result_top=`echo ${git_result} | tr " " "\n" | \
606 sort | uniq -c | sort -nr | head -n 3 | \
607 sed "s/^ \+[0-9]\+ \+//"`
608
609 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
610 sort -u | tr "\n" " " | sed "s/ $//" ;
611 else
612 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
613 sed "s/ $//" ;
614 fi
615
616 echo ""
617 }
618
619 # Each finished build will have a file called ${donep}${n},
620 # where n is the index of the build. Each build
621 # we've already noted as finished will have ${skipp}${n}.
622 # The code managing the build process will use this information
623 # to ensure that only BUILD_NBUILDS builds are in flight at once
624 donep="${LOG_DIR}/._done_"
625 skipp="${LOG_DIR}/._skip_"
626
627 build_target_killed() {
628 echo "Aborted $target build."
629 # Remove the logs for this board since it was aborted
630 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
631 exit
632 }
633
634 build_target() {
635 target=$1
636 build_idx=$2
637
638 if [ "$ONLY_LIST" == 'y' ] ; then
639 list_target ${target}
640 return
641 fi
642
643 if [ $BUILD_MANY == 1 ] ; then
644 output_dir="${OUTPUT_PREFIX}/${target}"
645 mkdir -p "${output_dir}"
646 trap build_target_killed TERM
647 else
648 output_dir="${OUTPUT_PREFIX}"
649 fi
650
651 export BUILD_DIR="${output_dir}"
652
653 target_arch=$(get_target_arch ${target})
654 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
655 if [ "${cross_toolchain}" ] ; then
656 MAKE="make CROSS_COMPILE=${cross_toolchain}"
657 elif [ "${CROSS_COMPILE}" ] ; then
658 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
659 else
660 MAKE=make
661 fi
662
663 ${MAKE} distclean >/dev/null
664 ${MAKE} -s ${target}_config
665
666 ${MAKE} ${JOBS} ${CHECK} all \
667 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
668
669 # Check for 'make' errors
670 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
671 RC=1
672 fi
673
674 if [ $BUILD_MANY == 1 ] ; then
675 trap - TERM
676
677 ${MAKE} -s tidy
678
679 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
680 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
681 else
682 rm ${LOG_DIR}/${target}.ERR
683 fi
684 else
685 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
686 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
687 : $(( ERR_CNT += 1 ))
688 ERR_LIST="${ERR_LIST} $target"
689 else
690 : $(( WRN_CNT += 1 ))
691 WRN_LIST="${WRN_LIST} $target"
692 fi
693 else
694 rm ${LOG_DIR}/${target}.ERR
695 fi
696 fi
697
698 OBJS=${output_dir}/u-boot
699 if [ -e ${output_dir}/spl/u-boot-spl ]; then
700 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
701 fi
702
703 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
704
705 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
706
707 touch "${donep}${build_idx}"
708 }
709
710 manage_builds() {
711 search_idx=${OLDEST_IDX}
712 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
713
714 while true; do
715 if [ -e "${donep}${search_idx}" ] ; then
716 : $(( CURRENT_CNT-- ))
717 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
718 : $(( OLDEST_IDX++ ))
719
720 # Only want to count it once
721 rm -f "${donep}${search_idx}"
722 touch "${skipp}${search_idx}"
723 elif [ -e "${skipp}${search_idx}" ] ; then
724 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
725 : $(( OLDEST_IDX++ ))
726 fi
727 : $(( search_idx++ ))
728 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
729 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
730 search_idx=${OLDEST_IDX}
731 sleep 1
732 else
733 break
734 fi
735 fi
736 done
737 }
738
739 build_targets() {
740 for t in "$@" ; do
741 # If a LIST_xxx var exists, use it. But avoid variable
742 # expansion in the eval when a board name contains certain
743 # characters that the shell interprets.
744 case ${t} in
745 *[-+=]*) list= ;;
746 *) list=$(eval echo '${LIST_'$t'}') ;;
747 esac
748 if [ -n "${list}" ] ; then
749 build_targets ${list}
750 else
751 : $((TOTAL_CNT += 1))
752 : $((CURRENT_CNT += 1))
753 rm -f "${donep}${TOTAL_CNT}"
754 rm -f "${skipp}${TOTAL_CNT}"
755 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
756 : $((SKIP_CNT += 1))
757 touch "${donep}${TOTAL_CNT}"
758 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
759 : $((SKIP_CNT += 1))
760 touch "${donep}${TOTAL_CNT}"
761 else
762 if [ $BUILD_MANY == 1 ] ; then
763 build_target ${t} ${TOTAL_CNT} &
764 else
765 CUR_TGT="${t}"
766 build_target ${t} ${TOTAL_CNT}
767 CUR_TGT=''
768 fi
769 fi
770 fi
771
772 # We maintain a running count of all the builds we have done.
773 # Each finished build will have a file called ${donep}${n},
774 # where n is the index of the build. Each build
775 # we've already noted as finished will have ${skipp}${n}.
776 # We track the current index via TOTAL_CNT, and the oldest
777 # index. When we exceed the maximum number of parallel builds,
778 # We look from oldest to current for builds that have completed,
779 # and update the current count and oldest index as appropriate.
780 # If we've gone through the entire list, wait a second, and
781 # reprocess the entire list until we find a build that has
782 # completed
783 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
784 manage_builds
785 fi
786 done
787 }
788
789 #-----------------------------------------------------------------------
790
791 kill_children() {
792 local OS=$(uname -s)
793 local children=""
794 case "${OS}" in
795 "Darwin")
796 # Mac OS X is known to have BSD style ps
797 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
798 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
799 ;;
800 *)
801 # everything else tries the GNU style
802 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
803 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
804 ;;
805 esac
806
807 kill $children 2> /dev/null
808 wait $children 2> /dev/null
809
810 exit
811 }
812
813 print_stats() {
814 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
815
816 # Only count boards that completed
817 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
818
819 rm -f ${donep}* ${skipp}*
820
821 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
822 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
823 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
824 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
825 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
826 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
827 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
828 else
829 # Remove the logs for any board that was interrupted
830 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
831 fi
832
833 : $((TOTAL_CNT -= ${SKIP_CNT}))
834 echo ""
835 echo "--------------------- SUMMARY ----------------------------"
836 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
837 echo "Boards skipped: ${SKIP_CNT}"
838 fi
839 echo "Boards compiled: ${TOTAL_CNT}"
840 if [ ${ERR_CNT} -gt 0 ] ; then
841 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
842 fi
843 if [ ${WRN_CNT} -gt 0 ] ; then
844 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
845 fi
846 echo "----------------------------------------------------------"
847
848 if [ $BUILD_MANY == 1 ] ; then
849 kill_children
850 fi
851
852 exit $RC
853 }
854
855 #-----------------------------------------------------------------------
856
857 # Build target groups selected by options, plus any command line args
858 set -- ${SELECTED} "$@"
859 # run PowerPC by default
860 [ $# = 0 ] && set -- powerpc
861 build_targets "$@"
862 wait